#ifndef ICI_EXEC_H
#define ICI_EXEC_H

#ifndef ICI_ARRAY_H
#include "array.h"
#endif

struct exec
{
    array_t x_xs;
    array_t x_os;
    array_t x_vs;
    int     x_count;
};

#ifdef MULTI

#include    "multi.h"

#define ex  (PROC_VARS->v_ex)
#define os  (&ex.x_os)
#define xs  (&ex.x_xs)
#define vs  (&ex.x_vs)
#define o_top   ex.x_os.a_top
#define x_top   ex.x_xs.a_top
#define v_top   ex.x_vs.a_top

#else

#define os  (&ex.x_os)
#define xs  (&ex.x_xs)
#define vs  (&ex.x_vs)
#define o_top   ex.x_os.a_top
#define x_top   ex.x_xs.a_top
#define v_top   ex.x_vs.a_top

extern DLI exec_t   ex;

#endif

#ifndef NODEBUGGING

/*
 * ICI debug interface.  exec() calls the functions in this interface
 * if debugging is enabled.  A default interface, with stubbed
 * implementations of these functions, is provided in the ICI core
 * (in idb2.c).  Debuggers will normally override the default with
 * a more useful set of functions.
 */
struct debug
{
    void    (*idbg_error)(char *, src_t *);
    void    (*idbg_fncall)(object_t *, object_t **, int);
    void    (*idbg_fnresult)(object_t *);
    void    (*idbg_src)(src_t *);
    void    (*idbg_watch)(object_t *, object_t *, object_t *);
};

#endif

#endif /* ICI_EXEC_H */
